import { ITimestampStruct } from '../../../json-crdt-patch/clock';
import { AbstractRga, Chunk } from '../rga/AbstractRga';
import type { JsonNode } from '../../types';
export declare class StringChunk implements Chunk<string> {
    readonly id: ITimestampStruct;
    span: number;
    del: boolean;
    data: string;
    len: number;
    p: StringChunk | undefined;
    l: StringChunk | undefined;
    r: StringChunk | undefined;
    p2: StringChunk | undefined;
    l2: StringChunk | undefined;
    r2: StringChunk | undefined;
    s: StringChunk | undefined;
    constructor(id: ITimestampStruct, span: number, str: string);
    merge(str: string): void;
    split(ticks: number): StringChunk;
    delete(): void;
    clone(): StringChunk;
}
export declare class StringRga extends AbstractRga<string> implements JsonNode {
    children(): void;
    child(): undefined;
    container(): JsonNode | undefined;
    private _view;
    view(): string;
    api: undefined | unknown;
    createChunk(id: ITimestampStruct, str: string | undefined): StringChunk;
    protected onChange(): void;
}
