import type { CompactContainsOp } from '../codec/compact/types';
import type { OperationContains } from '../types';
import { AbstractPredicateOp } from './AbstractPredicateOp';
import { Path } from '../../json-pointer';
import { OPCODE } from '../constants';
import { AbstractOp } from './AbstractOp';
import type { IMessagePackEncoder } from '../../json-pack/msgpack';
export declare class OpContains extends AbstractPredicateOp<'contains'> {
    readonly value: string;
    readonly ignore_case: boolean;
    constructor(path: Path, value: string, ignore_case: boolean);
    op(): "contains";
    code(): OPCODE;
    test(doc: unknown): boolean;
    toJson(parent?: AbstractOp): OperationContains;
    toCompact(parent: undefined | AbstractOp, verbose: boolean): CompactContainsOp;
    encode(encoder: IMessagePackEncoder, parent?: AbstractOp): void;
}
