import { ITimestampStruct } from '../../../json-crdt-patch/clock';
import { Model } from '../../model';
import type { Printable } from '../../../util/print/types';
import type { JsonNode } from '../../types';
export declare class ObjectLww implements JsonNode, Printable {
    protected readonly doc: Model;
    readonly id: ITimestampStruct;
    readonly keys: Map<string, ITimestampStruct>;
    constructor(doc: Model, id: ITimestampStruct);
    get(key: string): undefined | JsonNode;
    put(key: string, id: ITimestampStruct): undefined | ITimestampStruct;
    nodes(callback: (node: JsonNode, key: string) => void): void;
    children(callback: (node: JsonNode) => void): void;
    child(): undefined;
    container(): JsonNode | undefined;
    private _tick;
    private _view;
    view(): Readonly<Record<string, unknown>>;
    api: undefined | unknown;
    toString(tab?: string): string;
}
