"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.defineCrdtRoutes = void 0;
const tslib_1 = require("tslib");
const json_crdt_1 = require("../../json-crdt");
const defineCrdtRoutes = (router) => {
    return router.extend(({ t }) => {
        return {
            'crdt.create': t
                .Function(t.Object(t.propOpt('value', t.any).options({
                title: 'Initial value',
                description: 'Initial value of the JSON CRDT document. Can be any JSON value.',
            }), t.propOpt('sid', t.num).options({
                title: 'Session ID',
                description: 'Session ID to use for the logic clock of the document. If not provided, a random number will be used.',
            }), t.propOpt('serverClock', t.bool).options({
                title: 'Use server clock',
                description: 'Whether to use server logical clock for this document. If set to true, the session ID will be ignored set to 1.',
            })), t.Object(t.propOpt('doc', t.any).options({
                title: 'JSON CRDT document',
                description: 'JSON CRDT document.',
            })))
                .options({
                title: 'Create a CRDT document',
                description: 'Creates a new JSON CRDT document.',
            })
                .implement(({ value, sid, serverClock }) => tslib_1.__awaiter(void 0, void 0, void 0, function* () {
                const model = json_crdt_1.Model.withLogicalClock();
                return {
                    doc: model.toBinary(),
                };
            })),
        };
    });
};
exports.defineCrdtRoutes = defineCrdtRoutes;
