import { NewConOp, NewObjOp, NewValOp, NewVecOp, NewStrOp, NewBinOp, NewArrOp, InsValOp, InsObjOp, InsVecOp, InsStrOp, InsBinOp, InsArrOp, DelOp, NopOp } from './operations';
import { ITimestampStruct } from './clock';
import type { Printable } from '../util/print/types';
export type JsonCrdtPatchOperation = NewConOp | NewValOp | NewVecOp | NewObjOp | NewStrOp | NewBinOp | NewArrOp | InsValOp | InsObjOp | InsVecOp | InsStrOp | InsBinOp | InsArrOp | DelOp | NopOp;
export declare class Patch implements Printable {
    static fromBinary(data: Uint8Array): Patch;
    readonly ops: JsonCrdtPatchOperation[];
    meta: unknown;
    getId(): ITimestampStruct | undefined;
    span(): number;
    nextTime(): number;
    rewriteTime(ts: (id: ITimestampStruct) => ITimestampStruct): Patch;
    rebase(serverTime: number, transformHorizon: number): Patch;
    clone(): Patch;
    toBinary(): Uint8Array;
    toString(tab?: string): string;
}
