"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.find = void 0;
const ArrayRga_1 = require("../../types/rga-array/ArrayRga");
const ObjectLww_1 = require("../../types/lww-object/ObjectLww");
const json_pointer_1 = require("../../../json-pointer");
const ArrayLww_1 = require("../../types/lww-array/ArrayLww");
const find = (startNode, path) => {
    const steps = (0, json_pointer_1.toPath)(path);
    let node = startNode;
    const length = steps.length;
    if (!length)
        return node;
    let i = 0;
    while (i < length && node) {
        const step = steps[i++];
        node = node.container();
        if (!node)
            throw new Error('NOT_CONTAINER');
        if (node instanceof ObjectLww_1.ObjectLww) {
            const nextNode = node.get(String(step));
            if (!nextNode)
                throw new Error('NOT_FOUND');
            node = nextNode;
        }
        else if (node instanceof ArrayRga_1.ArrayRga) {
            const nextNode = node.getNode(Number(step));
            if (!nextNode)
                throw new Error('NOT_FOUND');
            node = nextNode;
        }
        else if (node instanceof ArrayLww_1.ArrayLww) {
            const nextNode = node.get(Number(step));
            if (!nextNode)
                throw new Error('NOT_FOUND');
            node = nextNode;
        }
    }
    return node;
};
exports.find = find;
